;;(defvar arabic-gstring nil)

(defun arabic-font-shape-gstring-ZWNJ-thin-width (gstring)
  (setq gstring (font-shape-gstring gstring))
  (dotimes (i (lgstring-glyph-len gstring))
    (let ((glyph (lgstring-glyph gstring i)))
      (if (eq (lglyph-char glyph) #x200c)
	  (let ((lbearing (lglyph-lbearing glyph))
		(rbearing (lglyph-rbearing glyph))
		(xoff nil))
	    (if (> (/ (+ rbearing lbearing) 2) 1)
		(setq xoff (- (/ (+ rbearing lbearing) 2))))
	    (lglyph-set-adjustment glyph xoff nil 1)))))
  (lgstring-set-id gstring nil)
  ;;(push gstring arabic-gstring)
  gstring)

;; Remove glyph at IDX from GSTRING.  This must go to composite.el.
(defun gstring-remove-glyph (gstring idx)
  (setq gstring (copy-sequence gstring))
  (lgstring-set-id gstring nil)
  (let ((len (length gstring)))
    (setq idx (+ idx 3))
    (while (< idx len)
      (aset gstring (1- idx) (aref gstring idx))
      (setq idx (1+ idx)))
    (aset gstring (1- len) nil))
  gstring)

(defun arabic-font-shape-gstring-ZWNJ-absorb (gstring)
  (setq gstring (font-shape-gstring gstring))
  (let ((i 1)
	(len (lgstring-glyph-len gstring)))
    (while (< i len)
      (let ((glyph (lgstring-glyph gstring i)))
	(if (eq (lglyph-char glyph) #x200c)
	    (let ((prev (lgstring-glyph gstring (1- i))))
	      (lglyph-set-from-to prev (lglyph-from prev) (lglyph-to glyph))
	      (setq gstring (gstring-remove-glyph gstring i))
	      (setq len (1- len)))
	  (setq i (1+ i))))))
  (lgstring-set-id gstring nil)
  ;;(push gstring arabic-gstring)
  gstring)

(defun arabic-font-shape-gstring-ZWNJ-as-space (gstring)
  (setq gstring (font-shape-gstring gstring))
  (let ((font (lgstring-font gstring))
	(i 1)
	(len (lgstring-glyph-len gstring)))
    (while (< i len)
      (let ((glyph (lgstring-glyph gstring i)))
	(when (eq (lglyph-char glyph) #x200c)
	  (if (> (- (lglyph-rbearing glyph) (lglyph-lbearing glyph)) 0)
	      (let ((space-glyph (aref (font-get-glyphs font 0 1 " ") 0)))
		(when space-glyph
		  (lglyph-set-code glyph (aref space-glyph 3))
		  (lglyph-set-width glyph (aref space-glyph 4)))))
	  (lglyph-set-adjustment glyph 0 0 1))
	(setq i (1+ i)))))
  (lgstring-set-id gstring nil)
  ;;(push gstring arabic-gstring)
  gstring)

;;(defvar arabic-font-shape-gstring 'arabic-font-shape-gstring-ZWNJ-thin-width)
;;(defvar arabic-font-shape-gstring 'arabic-font-shape-gstring-ZWNJ-absorb)
(defvar arabic-font-shape-gstring 'arabic-font-shape-gstring-ZWNJ-as-space)

(set-char-table-range
 composition-function-table
 '(#x600 . #x74F)
 (list (vector "[\u0600-\u074F\u200C\u200D]+" 0
	       arabic-font-shape-gstring)
       (vector "[\u200C\u200D][\u0600-\u074F\u200C\u200D]+" 1
	       arabic-font-shape-gstring)))
